package com.example.zcj;

import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import android.app.Activity;

public class MainActivity extends Activity {

    private EditText inputText;
    private Button generateButton;
    private TextView resultTextView;
    private Button copyButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        inputText = findViewById(R.id.inputText);
        generateButton = findViewById(R.id.button);
        resultTextView = findViewById(R.id.resultTextView);
        copyButton = findViewById(R.id.copyButton);

        generateButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    String machineCode = inputText.getText().toString();
                    String registrationCode = generateRegistrationCode(machineCode);
                    resultTextView.setText("注册码： " + registrationCode);
                }
            });

        copyButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    String registrationCode = resultTextView.getText().toString();
                    copyToClipboard(registrationCode);
                }
            });
    }

    private String generateRegistrationCode(String machineCode) {
        String input = machineCode + "xcheck225";
        String md5Hash = getMD5(input);
        String middlePart = md5Hash.substring(8, 24);
        BigInteger middlePartBI = new BigInteger(middlePart, 16);
        String registrationCode = middlePartBI.toString().substring(0, 8);
        return registrationCode;
    }

    private String getMD5(String input) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] messageDigest = md.digest(input.getBytes());
            BigInteger no = new BigInteger(1, messageDigest);
            String hashtext = String.format("%032x", no);
            return hashtext;
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("MD5 algorithm not found", e);
        }
    }

    private void copyToClipboard(String text) {
        ClipboardManager clipboard = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE);
        ClipData clip = ClipData.newPlainText("registrationCode", text);
        clipboard.setPrimaryClip(clip);
        Toast.makeText(this, "注册码已复制到剪贴板", Toast.LENGTH_SHORT).show();
    }
}
